unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls;

type
  TForm1 = class(TForm)
    Memo1: TMemo;
    OpenDialog1: TOpenDialog;
    Memo2: TMemo;
    Memo3: TMemo;
    Timer1: TTimer;
    CheckBox1: TCheckBox;
    CheckBox2: TCheckBox;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    ListBox1: TListBox;
    ListBox2: TListBox;
    Label4: TLabel;
    procedure FormShow(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure CheckBox2Click(Sender: TObject);
    procedure ListBox2Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

  TMesto=record
    nazev:String;
    x,y:integer; end;

  TCesta=record
    Zstr,Dostr:string;
    Zint,doint:integer;
    rychlost,delka,cena:integer;
    cas:single; end;

  TSpotreba=record
    rychlost:integer;
    litru:single; end;

  THrana=record
    delka,rychlost,cena:integer;
    cas:single; end;

var
  Form1: TForm1;
  mesta:array of TMesto;
  cesty:array of TCesta;
  spotreby:array of TSpotreba;
  minx,miny,rx,ry,maxspeed:integer;
  meritko:single;
  matice:array of array of THrana; {matice sousednosti}

implementation

{$R *.DFM}

//------------------------------------------------------------------------------
procedure MakeMatice;  //vytvoreni matice sousednosti
var i,j,max,rozdil,nejbliz:integer;
begin
  max:=Length(mesta)-1;
  SetLength(matice,max+1);
  for i:=0 to max do begin
    SetLength(Matice[i],max+1);
    for j:=0 to max do
      matice[i,j].delka:=-1; // neni cesta
  end;
  i:=0;
  while i<Length(cesty) do begin
    cesty[i].Zint:=-1;
    for j:=0 to max do if cesty[i].Zstr=mesta[j].nazev then cesty[i].Zint:=j;
    if cesty[i].Zint=-1 then begin
      Application.MessageBox('Nalezena chybna hrana - neexistujici startovni mesto','chyba',MB_OK);
      for j:=i to High(Cesty)-1 do Cesty[j]:=cesty[j+1];
      SetLength(cesty,High(cesty));
      continue; end;
    cesty[i].Doint:=-1;
    for j:=0 to max do if cesty[i].Dostr=mesta[j].nazev then cesty[i].DOint:=j;
    if cesty[i].Doint=-1 then begin
      Application.MessageBox('Nalezena chybna hrana - neexistujici cilove mesto','chyba',MB_OK);
      for j:=i to High(Cesty)-1 do Cesty[j]:=cesty[j+1];
      SetLength(cesty,High(cesty));
      continue; end;
    {prirazeni spotreby};
    nejbliz:=0;
    rozdil:=abs(cesty[i].rychlost-spotreby[0].rychlost);
    for j:=1 to high(spotreby) do begin
      if abs(cesty[i].rychlost-spotreby[j].rychlost)<rozdil then begin
        nejbliz:=j;
        rozdil:=abs(cesty[i].rychlost-spotreby[j].rychlost); end;
    end;
    cesty[i].cena:=round(cesty[i].delka*spotreby[nejbliz].litru/3.3);  {Zhruba cena v kc - 1l = 30Kc}
    cesty[i].cas:=cesty[i].delka/cesty[i].rychlost;
    matice[cesty[i].Zint,cesty[i].Doint].delka:=cesty[i].delka;
    matice[cesty[i].Zint,cesty[i].Doint].rychlost:=cesty[i].rychlost;
    matice[cesty[i].Zint,cesty[i].Doint].cena:=cesty[i].cena;
    matice[cesty[i].Zint,cesty[i].Doint].cas:=cesty[i].cas;
    matice[cesty[i].Doint,cesty[i].Zint].delka:=cesty[i].delka;
    matice[cesty[i].Doint,cesty[i].Zint].rychlost:=cesty[i].rychlost;
    matice[cesty[i].Doint,cesty[i].Zint].cena:=cesty[i].cena;
    matice[cesty[i].Doint,cesty[i].Zint].cas:=cesty[i].cas;
    inc(i);
  end;

  for i:=0 to max do
    Form1.ListBox1.Items.Add(mesta[i].nazev);
  Form1.CheckBox2Click(form1);
end;
//------------------------------------------------------------------------------
procedure Load; //nacteni xml souboru
var
  i,p,p2,j,k,maxx,maxy:integer;
  str:string;
  s:single;
begin
  if not Form1.OpenDialog1.execute then exit;
  Form1.Memo2.Text:='';
  Form1.Memo1.Lines.LoadFromFile(Form1.OpenDialog1.fileNAME);
  i:=0;
  minx:=0;
  maxx:=0;
  miny:=0;
  maxy:=0;
  maxspeed:=0;
  while Pos('<mapa>',Form1.Memo1.Lines.Strings[i])=0 do inc(i);
  while Pos('</mapa>',Form1.Memo1.Lines.Strings[i])=0 do begin
    if Pos('<mesto>',Form1.Memo1.Lines.Strings[i])>0 then begin
      inc(i);
      j:=Length(mesta);
      SetLength(mesta,j+1);
      while Pos('</mesto>',Form1.Memo1.Lines.Strings[i])=0 do begin
        if Pos('<nazev>',Form1.Memo1.Lines.Strings[i])>0 then begin
          p:=Pos('<nazev>',Form1.Memo1.Lines.Strings[i]);
          mesta[j].nazev:=Copy(Form1.Memo1.Lines.Strings[i],p+7,Pos('</nazev>',Form1.Memo1.Lines.Strings[i])-p-7);
          Form1.Memo2.Lines.Add(mesta[j].nazev);
        end;
        if Pos('<polohaX>',Form1.Memo1.Lines.Strings[i])>0 then begin
          p:=Pos('<polohaX>',Form1.Memo1.Lines.Strings[i]);
          mesta[j].x:=StrToIntDef(Copy(Form1.Memo1.Lines.Strings[i],p+9,Pos('</polohaX>',Form1.Memo1.Lines.Strings[i])-p-9),0);
          if mesta[j].x<minx then minx:=mesta[j].x;
          if mesta[j].x>maxx then maxx:=mesta[j].x;
          Form1.Memo2.Lines.Add('X: '+IntToStr(mesta[j].x));
        end;
        if Pos('<polohaY>',Form1.Memo1.Lines.Strings[i])>0 then begin
          p:=Pos('<polohaY>',Form1.Memo1.Lines.Strings[i]);
          mesta[j].y:=StrToIntDef(Copy(Form1.Memo1.Lines.Strings[i],p+9,Pos('</polohaY>',Form1.Memo1.Lines.Strings[i])-p-9),0);
          if mesta[j].y<miny then miny:=mesta[j].y;
          if mesta[j].y>maxy then maxy:=mesta[j].y;
          Form1.Memo2.Lines.Add('Y: '+IntToStr(mesta[j].y));
        end;
        inc(i);
      end;
      Form1.Memo2.Lines.Add('');
    end;
    if Pos('<cesta>',Form1.Memo1.Lines.Strings[i])>0 then begin
      inc(i);
      j:=Length(cesty);
      SetLength(cesty,j+1);
      while Pos('</cesta>',Form1.Memo1.Lines.Strings[i])=0 do begin
        if Pos('<z>',Form1.Memo1.Lines.Strings[i])>0 then begin
          p:=Pos('<z>',Form1.Memo1.Lines.Strings[i]);
          cesty[j].zstr:=Copy(Form1.Memo1.Lines.Strings[i],p+3,Pos('</z>',Form1.Memo1.Lines.Strings[i])-p-3);
          Form1.Memo2.Lines.Add('Z: '+cesty[j].zstr);
        end;
        if Pos('<do>',Form1.Memo1.Lines.Strings[i])>0 then begin
          p:=Pos('<do>',Form1.Memo1.Lines.Strings[i]);
          cesty[j].dostr:=Copy(Form1.Memo1.Lines.Strings[i],p+4,Pos('</do>',Form1.Memo1.Lines.Strings[i])-p-4);
          Form1.Memo2.Lines.Add('Do: '+cesty[j].dostr);
        end;
        if Pos('<vzdalenost>',Form1.Memo1.Lines.Strings[i])>0 then begin
          p:=Pos('<vzdalenost>',Form1.Memo1.Lines.Strings[i]);
          cesty[j].delka:=StrToIntDef(Copy(Form1.Memo1.Lines.Strings[i],p+12,Pos('</vzdalenost>',Form1.Memo1.Lines.Strings[i])-p-12),0);
          Form1.Memo2.Lines.Add('delka: '+IntToStr(cesty[j].delka));
        end;
        if Pos('<prumernaRychlost>',Form1.Memo1.Lines.Strings[i])>0 then begin
          p:=Pos('<prumernaRychlost>',Form1.Memo1.Lines.Strings[i]);
          cesty[j].rychlost:=StrToIntDef(Copy(Form1.Memo1.Lines.Strings[i],p+18,Pos('</prumernaRychlost>',Form1.Memo1.Lines.Strings[i])-p-18),0);
          if cesty[j].rychlost>maxspeed then maxspeed:=cesty[j].rychlost;
          Form1.Memo2.Lines.Add('rychlost: '+IntToStr(cesty[j].rychlost));
        end;
        inc(i);
      end;
      Form1.Memo2.Lines.Add(''); end;
    if Pos('<spotreba>',Form1.Memo1.Lines.Strings[i])>0 then begin
      inc(i);
      j:=Length(spotreby);
      SetLength(spotreby,j+1);
      while Pos('</spotreba>',Form1.Memo1.Lines.Strings[i])=0 do begin
        if Pos('<rychlost>',Form1.Memo1.Lines.Strings[i])>0 then begin
          p:=Pos('<rychlost>',Form1.Memo1.Lines.Strings[i]);
          spotreby[j].rychlost:=StrToIntDef(Copy(Form1.Memo1.Lines.Strings[i],p+10,Pos('</rychlost>',Form1.Memo1.Lines.Strings[i])-p-10),0);
          Form1.Memo3.Lines.Add('rychlost '+IntToStr(spotreby[j].rychlost)+' km/h');
        end;
        if Pos('<litru>',Form1.Memo1.Lines.Strings[i])>0 then begin
          p:=Pos('<litru>',Form1.Memo1.Lines.Strings[i]);
          p2:=Pos('.',Form1.Memo1.Lines.Strings[i]);
          if p2=0 then
            spotreby[j].litru:=StrToFloat(Copy(Form1.Memo1.Lines.Strings[i],p+7,Pos('</litru>',Form1.Memo1.Lines.Strings[i])-p-7)+'E0')
          else begin
            spotreby[j].litru:=StrToFloat(Copy(Form1.Memo1.Lines.Strings[i],p+7,p2-p-7));
            str:=Copy(Form1.Memo1.Lines.Strings[i],p2+1,Pos('</litru>',Form1.Memo1.Lines.Strings[i])-p2-1);
            s:=1;
            k:=0;
            while k<Length(str) do begin
              s:=s/10;
              inc(k); end;
            spotreby[j].litru:=spotreby[j].litru+StrToInt(str)*s; end;
          Form1.Memo3.Lines.Add('litru: '+FloatToStr(spotreby[j].litru));
        end;
        inc(i); end;
      Form1.Memo2.Lines.Add(''); end;

    inc(i); end;
  //umisteni mest
  rx:=maxx-minx;
  ry:=maxy-miny;
  if rx>ry then begin
    meritko:=500/rx;
    miny:=miny-round((rx-ry)/2); end
  else begin
    meritko:=500/ry;
    minx:=minx-round((ry-rx)/2); end;
  for i:=0 to Length(mesta)-1 do begin
    mesta[i].x:=round((mesta[i].x-minx)*meritko)+5;
    mesta[i].y:=round((mesta[i].y-miny)*meritko)+25; end;
  makematice;
end;
//------------------------------------------------------------------------------
procedure zobrazC;
var
  i,n:integer;
begin
  for i:=0 to High(cesty) do begin
    n:=round(200*cesty[i].rychlost/maxspeed);
    Form1.Canvas.Pen.color:=RGB(n,n,n);
    Form1.Canvas.MoveTo(mesta[cesty[i].Zint].x,mesta[cesty[i].Zint].y);
    Form1.Canvas.LineTo(mesta[cesty[i].Doint].x,mesta[cesty[i].Doint].y); end;
end;
//------------------------------------------------------------------------------
procedure TForm1.FormShow(Sender: TObject);
begin
  Load;
end;
//------------------------------------------------------------------------------
procedure TForm1.Timer1Timer(Sender: TObject);
var i:integer;
begin
  {pro zobrazeni mapy}
  Form1.Canvas.Brush.Style:=bsSolid;
  Form1.Canvas.Pen.color:=clwhite;
  Form1.Canvas.brush.color:=clwhite;
  Form1.Canvas.Rectangle(0,0,550,550);
  Form1.Canvas.Pen.color:=clBlack;
  for i:=0 to Length(mesta)-1 do begin
    Form1.Canvas.Brush.Style:=bsSolid;
    Form1.Canvas.MoveTo(mesta[i].x-1,mesta[i].y);
    Form1.Canvas.LineTo(mesta[i].x+2,mesta[i].y);
    Form1.Canvas.MoveTo(mesta[i].x,mesta[i].y-1);
    Form1.Canvas.LineTo(mesta[i].x,mesta[i].y+2);
    Form1.Canvas.Brush.Style:=bsClear;
    Form1.Canvas.TextOut(mesta[i].x+2,mesta[i].y+2,mesta[i].nazev); end;
  if Form1.Checkbox1.Checked then zobrazC;
end;
//------------------------------------------------------------------------------
procedure TForm1.CheckBox2Click(Sender: TObject);
var i:integer;
begin
  Form1.ListBox2.Items.Clear;
  if Form1.CheckBox2.checked then begin
    if Form1.ListBox1.ItemIndex<0 then exit;
    for i:=0 to High(mesta) do
      if matice[Form1.ListBox1.ItemIndex,i].delka>-1 then
        Form1.ListBox2.Items.Add(mesta[i].nazev);
  end
  else
    for i:=0 to High(mesta) do
      Form1.ListBox2.Items.Add(mesta[i].nazev);
end;

procedure TForm1.ListBox2Click(Sender: TObject);
var d,i:integer;
begin
  {vypis okolniho mesta}
  if (Checkbox2.checked) and (Listbox2.ItemIndex>-1) and (Listbox1.ItemIndex>-1) then begin
    d:=-1;
    i:=0;
    repeat
      if matice[Listbox1.ItemIndex,i].delka>-1 then inc(d);
      inc(i);
    until  d=Listbox2.ItemIndex;
    d:=i-1;
    Label4.Caption:='Delka: '+IntToStr(matice[d,Listbox1.ItemIndex].delka) + ' km, '+
      FloatToStr(matice[d,Listbox1.ItemIndex].cas)+ ' hod; '+
      IntToStr(matice[d,Listbox1.ItemIndex].cena)+' Kc'; end;
end;

end.
